<template>
  <div>
    <div class="container">
      <br />
      <br />
      <div class="vx-col md:90% w-full mb-base">
        <vx-card title="Busca SCR">
          <div class="vx-row mb-6">
            <div class="vx-col sm:w-1/5 w-full mb-2">
              <vs-input class="w-full" icon-pack="feather" icon="icon-edit" icon-no-border label="CPF/CNPJ" id="client"
                v-model="value" required />
            </div>

            <div class="vx-col sm:w-1/5 w-full mb-2">
              <vs-input class="w-full" icon-pack="feather" icon="icon-edit" icon-no-border label="CPF do usuario"
                id="user" v-model="userDocument" required />
            </div>

            <div class="vx-col sm:w-1/5 w-full mb-2">
              <vs-select class="selectExample" label="Mês" v-model="select1">
                <vs-select-item icon="icon-edit" icon-no-border :key="index" :value="item.value" :text="item.text"
                  v-for="(item, index) in months" />
              </vs-select>
            </div>

            <div class="vx-col sm:w-1/5 w-full mb-2">
              <vs-select class="selectExample" label="Ano" v-model="select2">
                <vs-select-item icon="icon-edit" icon-no-border :key="index" :value="item.value" :text="item.text"
                  v-for="(item, index) in years" />
              </vs-select>
            </div>

            <div class="vx-col sm:w-1/5 w-full mb-2" @click="validation">
              <vs-button>
                <feather-icon icon="SearchIcon" />
              </vs-button>
            </div>
          </div>
          <vs-alert :active="userStatus" color="danger" title="Erro">
            Usuario Invalido !
          </vs-alert>

          <vs-alert :active="alertStatus" color="danger" title="Erro">
            Campos Vazios ! Preencha todos os campos corretamente.
          </vs-alert>
          <vs-alert :active="dateStatus" color="danger" title="Erro">
            Data inválida! Informação indisponível para a data solicitada.
          </vs-alert>
        </vx-card>
      </div>
    </div>

    <loading :active.sync="isLoading" :can-cancel="true" :is-full-page="fullPage"></loading>

    <div>
      <div class="container">
        <vx-card title="Informações">
          <br />

          <vs-table :data="informationTable">
            <template slot="thead">
              <vs-th>A Vencer</vs-th>
              <vs-th>Vencido</vs-th>
              <vs-th>Prejuizo</vs-th>
              <vs-th>Carteira Crédito</vs-th>
              <vs-th>Repasses Interfinanceiros</vs-th>
              <vs-th>Coobrigações</vs-th>
            </template>

            <template slot-scope="{ data }">
              <vs-tr :key="indextr" v-for="(tr, indextr) in data">
                <vs-td :data="data[indextr].toWin">
                  {{ data[indextr].toWin }}
                </vs-td>
                <vs-td :data="data[indextr].due">
                  {{ data[indextr].due }}
                </vs-td>
                <vs-td :data="data[indextr].loss">
                  {{ data[indextr].loss }}
                </vs-td>
                <vs-td :data="data[indextr].creditPortfolio">
                  {{ data[indextr].creditPortfolio }}
                </vs-td>
                <vs-td :data="data[indextr].transfers">
                  {{ data[indextr].transfers }}
                </vs-td>
                <vs-td :data="data[indextr].coobligations">
                  {{ data[indextr].coobligations }}
                </vs-td>
              </vs-tr>
            </template>
          </vs-table>
        </vx-card>
      </div>

      <br />
      <div class="container">
        <vx-card>
          <vs-table :data="tableInformation">
            <template slot="thead">
              <vs-th>Responsabilidade Total</vs-th>
              <vs-th>Crédito a liberar</vs-th>
              <vs-th>Limite de crédito</vs-th>
              <vs-th>Risco Indireto</vs-th>
              <vs-th>Risco Total</vs-th>
            </template>

            <template slot-scope="{ data }">
              <vs-tr :key="indextr" v-for="(tr, indextr) in data">
                <vs-td :data="data[indextr].fullResponsibility">
                  {{ data[indextr].fullResponsibility }}
                </vs-td>
                <vs-td :data="data[indextr].openCredit">
                  {{ data[indextr].openCredit }}
                </vs-td>
                <vs-td :data="data[indextr].creditLimit">
                  {{ data[indextr].creditLimit }}
                </vs-td>
                <vs-td :data="data[indextr].indirectRisk">
                  {{ data[indextr].indirectRisk }}
                </vs-td>
                <vs-td :data="data[indextr].totalRisk">
                  {{ data[indextr].totalRisk }}
                </vs-td>
              </vs-tr>
            </template>
          </vs-table>
        </vx-card>
      </div>
    </div>
    <br />
    <div>
      <div class="container">
        <vx-card stripe title="Detalhes">
          <vs-table :data="tableOperation">
            <template slot="thead">
              <vs-th>Descrição</vs-th>
              <vs-th>Valor</vs-th>
            </template>

            <template slot-scope="{ data }">
              <vs-tr :key="indextr" v-for="(tr, indextr) in data">
                <vs-td :data="data[indextr].item">
                  {{ data[indextr].item }}
                </vs-td>
                <vs-td :data="data[indextr].values">
                  {{ data[indextr].values }}
                </vs-td>
              </vs-tr>
            </template>
          </vs-table>
        </vx-card>
      </div>
    </div>
    <br />
    <div>
      <div class="container">
        <vx-card title="Detalhes">
          <vs-table :data="tableFiles">
            <template slot="thead">
              <vs-th>Tipo</vs-th>
              <vs-th>Dominio</vs-th>
              <vs-th>Sub-Domínio</vs-th>
              <vs-th>Valor</vs-th>
            </template>

            <template slot-scope="{ data }">
              <vs-tr :key="indextr" v-for="(tr, indextr) in data">
                <vs-td :data="data[indextr].type">
                  {{ data[indextr].type }}
                </vs-td>
                <vs-td :data="data[indextr].domain">
                  {{ data[indextr].domain }}
                </vs-td>
                <vs-td :data="data[indextr].subdomain">
                  {{ data[indextr].subdomain }}
                </vs-td>
                <vs-td :data="data[indextr].amount">
                  {{ data[indextr].amount }}
                </vs-td>
              </vs-tr>
            </template>
          </vs-table>
        </vx-card>
      </div>
    </div>
    <br />
    <br />
  </div>
</template>

<script>
  const formatador = new Intl.NumberFormat("pt-BR", {
    style: "currency",
    currency: "BRL",
  });
  const axios = require("axios");

  // Import stylesheet
  import "vue-loading-overlay/dist/vue-loading.css";
  import Cleave from "vue-cleave-component";
  import Loading from "vue-loading-overlay";

  let detail = "";
  import {
    BRow,
    BCol,
    BFormGroup,
    BFormInput,
    BFormCheckbox,
    BForm,
    BButton,
    BInputGroup,
    BInputGroupPrepend,
    BProgress,
    BFormSelect,
  } from "bootstrap-vue";
  import Ripple from "vue-ripple-directive";
  import moment from 'moment';

  export default {
    components: {
      BRow,
      BCol,
      BFormGroup,
      BFormInput,
      BFormCheckbox,
      BInputGroup,
      BInputGroupPrepend,
      BForm,
      BProgress,
      BButton,
      Loading,
      BFormSelect,
      Cleave,
    },
    data() {
      return {
        months: [{
            text: "Janeiro",
            value: "01"
          },
          {
            text: "Fevereiro",
            value: "02"
          },
          {
            text: "Março",
            value: "03"
          },
          {
            text: "Abril",
            value: "04"
          },
          {
            text: "Maio",
            value: "05"
          },
          {
            text: "Junho",
            value: "06"
          },
          {
            text: "Julho",
            value: "07"
          },
          {
            text: "Agosto",
            value: "08"
          },
          {
            text: "Setembro",
            value: "09"
          },
          {
            text: "Outubro",
            value: "10"
          },
          {
            text: "Novembro",
            value: "11"
          },
          {
            text: "Dezembro",
            value: "12"
          },
        ],
        years: [{
            text: "2000",
            value: "2000"
          },
          {
            text: "2001",
            value: "2001"
          },
          {
            text: "2002",
            value: "2002"
          },
          {
            text: "2003",
            value: "2003"
          },
          {
            text: "2003",
            value: "2003"
          },
          {
            text: "2004",
            value: "2004"
          },
          {
            text: "2005",
            value: "2005"
          },
          {
            text: "2006",
            value: "2006"
          },
          {
            text: "2007",
            value: "2007"
          },
          {
            text: "2008",
            value: "2008"
          },
          {
            text: "2009",
            value: "2009"
          },
          {
            text: "2010",
            value: "2010"
          },
          {
            text: "2011",
            value: "2011"
          },
          {
            text: "2011",
            value: "2011"
          },
          {
            text: "2012",
            value: "2012"
          },
          {
            text: "2013",
            value: "2013"
          },
          {
            text: "2014",
            value: "2014"
          },
          {
            text: "2015",
            value: "2015"
          },
          {
            text: "2016",
            value: "2016"
          },
          {
            text: "2017",
            value: "2017"
          },
          {
            text: "2018",
            value: "2018"
          },
          {
            text: "2019",
            value: "2019"
          },
          {
            text: "2020",
            value: "2020"
          },
          {
            text: "2021",
            value: "2021"
          },
        ],
        dateStatus: false,
        alertStatus: false,
        userStatus: false,
        select1: "",
        select2: "",
        month: "",
        isLoading: false,
        fullPage: true,
        value: "",
        date: {
          date: true,
          delimiter: "/",
          datePattern: ["m", "Y"],
          length: 8,
        },
        tableList: [
          "vs-th: Component",
          "vs-tr: Component",
          "vs-td: Component",
          "thread: Slot",
          "tbody: Slot",
          "header: Slot",
        ],
        informationTable: [],
        tableInformation: [],
        tableOperation: [],
        tableFiles: [],
      };
    },
    VxCarddirectives: {
      Ripple,
    },
    methods: {
      async teste() {
        let documentInterprise = this.value;
        let month = this.select1;
        let year = this.select2;
        // let month = this.month.value;

        if (documentInterprise != "" && month != "" && year != "") {
          this.alertStatus = false;

          this.isLoading = true;
          var data = JSON.stringify({
            auth: {
              Usuario: "luiz.casante@viainvest.com.br",
              Senha: "Viainvest!2022",
              CodigoParametro: "VIAINVEST_SCR",
              Chave: "5c63f466-a6ee-4792-8cd9-a310cd68f7e3"
            },
            consulta: {
              Documento: documentInterprise,
              DataBaseMes: month,
              DataBaseAno: year,
              IpCliente: "187.122.11.53",
              IpIntegrador: "187.122.11.53",
              DtAceiteCliente: "2021-02-23T14:53:50.710Z",
              Observacoes: "",
              Operador: "",
              Senha: "",
              DocumentoIntegrador: "",
              CodigoEmpresa: "",
            },
          });

          var config = {
            method: "post",
            url: "https://bmpdigital.moneyp.com.br/api/BMPDigital/ConsultaSCR",
            headers: {
              "Content-Type": "application/json",
            },
            data: data,
          };

          const response = await axios(config);
          const information = response.data;


          //tabela informationTable
          if (!information.Erro) {
            this.dateStatus = false;
            const dataAdvice = [{
              toWin: formatador.format(
                information.ResumoDoClienteTraduzido.CarteiraVencer
              ),
              due: formatador.format(
                information.ResumoDoClienteTraduzido.CarteiraVencido
              ),
              loss: formatador.format(
                information.ResumoDoClienteTraduzido.Prejuizo
              ),
              creditPortfolio: formatador.format(
                information.ResumoDoClienteTraduzido.CarteiradeCredito
              ),
              transfers: formatador.format(
                information.ResumoDoClienteTraduzido.Repasses
              ),
              coobligations: formatador.format(
                information.ResumoDoClienteTraduzido.Coobrigacoes
              ),
            }, ];

            const dataInformation = [{
              fullResponsibility: formatador.format(
                information.ResumoDoClienteTraduzido.ResponsabilidadeTotal
              ),
              openCredit: formatador.format(
                information.ResumoDoClienteTraduzido.CreditosaLiberar
              ),
              creditLimit: formatador.format(
                information.ResumoDoClienteTraduzido.LimitesdeCredito
              ),
              indirectRisk: formatador.format(
                information.ResumoDoClienteTraduzido.RiscoIndiretoVendor
              ),
              totalRisk: formatador.format(
                information.ResumoDoClienteTraduzido.RiscoTotal
              ),
            }, ];
            //tabela tableOperation
            const operation = [{
                item: "Início do Relacionamento",
                values: information.ResumoDoClienteTraduzido.DtInicioRelacionamento,
              },
              {
                item: "Quantidade de Intituições Financeiras",
                values: information.ResumoDoClienteTraduzido.QtdeInstituicoes,
              },
              {
                item: "Quantidade de Operações",
                values: information.ResumoDoClienteTraduzido.QtdeOperacoes,
              },
              {
                item: "Quantidade de Operações em Discordancia",
                values: information.ResumoDoClienteTraduzido.QtdeOperacoesDiscordancia,
              },
              {
                item: "Valor de Operações em Discordancia",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.VlrOperacoesDiscordancia
                ),
              },
              {
                item: "Quantidade de Operações Sob Judice",
                values: information.ResumoDoClienteTraduzido.QtdeOperacoesSobJudice,
              },
              {
                item: "Valor de Operações Sob Judice",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.VlrOperacoesSobJudice
                ),
              },
              {
                item: "Carteira a Vencer Até 30 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido
                  .CarteiraVencerAte30diasVencidosAte14dias
                ),
              },
              {
                item: "Carteira a Vencer de 31 dias a 60 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.CarteiraVencer31a60dias
                ),
              },
              {
                item: "Carteira a Vencer de 61 dias a 90 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.CarteiraVencer61a90dias
                ),
              },
              {
                item: "Carteira a Vencer de 91 dias a 180 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.CarteiraVencer91a180dias
                ),
              },
              {
                item: "Carteira a Vencer de 181 dias a 360 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.CarteiraVencer181a360dias
                ),
              },
              {
                item: "Carteira a Vencer Acima de 360 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.CarteiraVencerAcima360dias
                ),
              },
              {
                item: "Carteira a Vencer Prazo Indeterminado",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido
                  .CarteiraVencerPrazoIndeterminado
                ),
              },
              {
                item: "Carteira Vencido Até 30 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.CarteiraVencido15a30dias
                ),
              },
              {
                item: "Carteira Vencido de 31 dias a 60 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.CarteiraVencido31a60dias
                ),
              },
              {
                item: "Carteira Vencido de 61 dias a 90 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.CarteiraVencido61a90dias
                ),
              },
              {
                item: "Carteira Vencido de 91 dias a 180 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.CarteiraVencido91a180dias
                ),
              },
              {
                item: "Carteira Vencido de 181 dias a 360 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.CarteiraVencido181a360dias
                ),
              },
              {
                item: "Carteira Vencido Acima de 360 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.CarteiraVencidoAcima360dias
                ),
              },
              {
                item: "Prejuizo até 360 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.PrejuizoAte12meses
                ),
              },
              {
                item: "Prejuizo Acima de 360 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.PrejuizoAcima12meses
                ),
              },
              {
                item: "Limites de Crédito até 360 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.PrejuizoAte12meses
                ),
              },
              {
                item: "Limites de Crédito Acima 360 dias",
                values: formatador.format(
                  information.ResumoDoClienteTraduzido.PrejuizoAcima12meses
                ),
              },
            ];

            detail = {
              type: "",
              domain: "",
              subdomain: "",
              amount: "",
            };

            const transactions = information.ResumoModalidade;
            const filtered = transactions.filter(function (maxipagoList) {
              return maxipagoList.valorVencimento != 0;
            });

            let files = [];

            for (const param of filtered) {
              detail.type = param.tipo;
              detail.domain = param.dominio;
              detail.subdomain = param.subdominio;
              detail.amount = formatador.format(param.valorVencimento);
              files.push(Object.assign({}, detail));
            }

            //popula as tabelas
            this.informationTable = dataAdvice;
            this.tableInformation = dataInformation;
            this.tableOperation = operation;
            this.tableFiles = files;

            files = "";
            this.isLoading = false;
          } else {
            this.isLoading = false;
            this.dateStatus = true;
          }
        } else {
          this.alertStatus = true;
        }
      },
      async validation() {
        this.alertStatus = false
        let user = this.userDocument

        var config = {
          method: 'get',
          url: "https://data-miner.portalsoulpay.com.br/api/v1/permissions/" + user,
          headers: {}
        };

        const response = await axios(config);
        const informationUser = response.data;
        const id = informationUser.id

        const data = moment().utc(3).format("YYYY-MM-DD HH:MM:SS")


        if (user == informationUser.taxName) {
          this.userStatus = false
          var params = JSON.stringify({
            "user": id,
            "document": informationUser.taxName,
            "data": data
          });
          var send = {
            method: 'post',
            url: 'https://data-miner.portalsoulpay.com.br/api/v1/scrhistory',
            headers: {
              'Content-Type': 'application/json'
            },
            data: params
          };
          await axios(send);

          await this.teste()

        } else {
          this.userStatus = true
        }
      },






    },
  };

</script>
